#!/usr/bin/perl

########################################
#                                      #
# C O N F I G U R A T I O N            #
#                                      #
########################################

$dbusername = "username";
$dbpassword = "password";

########################################
#                                      #
# I N C L U D E S                      #
#                                      #
########################################

use DBI;
require "common.pl";

########################################
#                                      #
# M A I N                              #
#                                      #
########################################

%cookies = ();
$cookiecount = 0;
dbconnect();
checkcookie();
decode();

if ( $action =~ /^1$/ ) { validate(); }
else { main(); }

exit;

########################################
#                                      #
# S U B S                              #
#                                      #
########################################

sub htmlheader {

	if ( $cookiecount > 0 ) {
	
		# set cookies
		foreach $key ( keys %cookies ) {
		
			$val = $cookies{ $key };
			
			# encrypt the $key
			$sql = "SELECT var,value FROM encryptedvars";
			$sth1 = $dbh1->prepare( $sql );
			$rv1 = $sth1->execute();
			if ( $rv1 =~ /^0E0/ ) {
	
				printerr( "Error getting data from the DB [1]\n" );
				exit;
	
			} else {
	
				while ( ( $var, $val1 ) = $sth1->fetchrow_array() ) {
		
					if ( $key =~ /^$var$/ ) { $keyvar = $val1; }
		
				}
	
			}
			
			$line = "Set-Cookie: $keyvar=$val\n";
			print "$line";
			push( @lines, $line );
		
		}
	
	} 
	
	print "Content-type: text/html\n\n";
	print "
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">
<html>
<head>
  <title>Sample CGI App</title>
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
  <meta name=\"GENERATOR\" content=\"Perl CGI\">
</head>
<body>
	";

}

sub htmlfooter {

	print "</body></html>";

}

sub main {

	htmlheader();
	print "
<h3>Login</h3>
<p>
  <form action=\"/cgi-bin/login.pl\">
    <input type=\"hidden\" name=\"action\" value=1>
      <table width=400 align=\"center\">
        <tr>
          <td width=150 bgcolor=\"#e4e4e4\"><div align=\"center\"><b>Username</b></div></td>
          <td><div align=\"center\"><input type=\"text\" name=\"username\"></div></td>
        </tr>
        <tr>
          <td width=150 bgcolor=\"#e4e4e4\"><div align=\"center\"><b>Password</b></div></td>
          <td><div align=\"center\"><input type=\"password\" name=\"password\"></div></td>
        </tr>
        <tr>
          <td colspan=\"2\"><div align=\"center\"><input type=\"submit\"><input type=\"reset\"></div></td>
        </tr>
      </table>
  </form>
</p>
<hr>
<h3>New Users</h3>
<p>
  New users can register on <a href=\"/cgi-bin/userreg.pl\">this page...</a>
</p>
	";
	htmlfooter();
	exit;

}

sub validate {

	# we have $username and $password. If it matches, set the session cookie
	$sql1 = "SELECT IF( password = MD5('$password' ), 'yes', 'no' ) FROM users WHERE uid = '$username'";
	$sth1 = $dbh1->prepare( $sql1 );
	$rv1 = $sth1->execute();
	if ( $rv1 =~ /^0E0/ ) {
	
		printerr( "Error getting data from the DB [2]\n" );
		exit;
	
	} else {
	
		while ( ( $result ) = $sth1->fetchrow_array() ) {
		
			if ( $result =~ /^no/i ) {
			
				# login failed - error
				printerr( "Login Failed [1] " );
				exit;
			
			}
		
		}
	
	}

	# set-up the session
	$now = time;
	$session = $now . $username;
	$sql2 = "UPDATE users SET sessionid = MD5( '$session' ), sessionactivity = NOW() WHERE uid = '$username'";
	$dbh1->do( $sql2 );
	
	# now get the encoded uid and sessionid and set the cookies
	$sql3 = "SELECT uidencoded,sessionid FROM users WHERE uid = '$username'";
	$sth3 = $dbh1->prepare( $sql3 );
	$rv3 = $sth3->execute();
	if ( $rv3 =~ /^0E0/ ) {
	
		printerr( "Error getting data from the DB [3]\n" );
		exit;
	
	} else {
	
		while ( ( $encuid, $encsesid ) = $sth3->fetchrow_array() ) {
		
			$cookies{'userid'} = $encuid;
			$cookies{'sessionid'} = $encsesid;
			$cookiecount = 2;
			
		}
	
	}
	
	# finally - display the result
	htmlheader();
	print "Succesful login. You can now go to the <a href=\"/cgi-bin/index.pl\">index page</a>.";
	
	print "
<hr><h3>Debug</h3>
	";
	foreach $line ( @lines ) {
	
		print "Cookieline :: $line<br>\n";
	
	}
	print "sql3=$sql3<br>\n";
	
	htmlfooter();
	exit;

}
